

import addbk.JAddressBook.AddressRecord;
import addbk.JAddressBook.AddressDataBase;
import gui.dialogs.ProgressDialog;

import java.beans.XMLEncoder;
import java.io.*;
import java.net.URL;
import java.util.Vector;

// SW409 4/6/05
// For homework, convert the main method so that it will populate
// the addressbook database in the JAddressBook package.
// Use address Records and an SAX parser to read the string output.
/*
Print a CD Label
Make the dimensions correct
Use the files in a given folder as your labels.
Directories start with a /
Use the dir-lister to get the files. Or futils.Ls, as shown in class.
Arrange the files in alphabetical order
Include a date at the top of the list (i.e. 20050406)
126 mm w X
121 mm h
2.83 Pts/mm
357x342 Points (wxh)

*/

public class UrlUtils {
    static Vector v = new Vector();


    public static Vector lookForIPLawyersInUsa(int stateNumber, int pageNumber) {
        String s2 =
                "http://www.lawyers.com/find_a_lawyer/search/results.php?country=1&firmname=&firstname=&lastname=&searchtype=Q&termtype=1&personalaop=756&personalterm=&businessaop=&businessterm=&language=&pagenum=&city=&county=&" +
                "state=" +
                stateNumber +
                "&country=1&site=466&lm_id=&resultcount=126&sed=2487187&displaycount=126&sorttype=0" +
                "&pagenum=" +
                pageNumber;
        return getUrlVector(s2);
    }

    public static Vector lookForIPLawyersInCt(int pageNumber) {
        String s2 =
                "http://www.lawyers.com/find_a_lawyer/search/results.php?country=1&firmname=&firstname=&lastname=&searchtype=Q&termtype=1&personalaop=756&personalterm=&businessaop=&businessterm=&language=&pagenum=&city=&county=&" +
                "state=7&country=1&site=466&lm_id=&resultcount=126&sed=2487187&displaycount=126&sorttype=0" +
                "&pagenum=" +
                pageNumber;
        return getUrlVector(s2);
    }

//    public static Vector lookForJobs(String keyword) {
//        return
//                getUrlVector
//                //("http://jobsearch.monster.com/jobsearch.asp?q="+keyword);
//                ("http://trading.etrade.com/cgi-bin/gx.cgi/Applogic+IPOCurrent");
//    }
    // todo populate the address book with lawyers
    //Refer to Main.java; this main is not used.
    public static void main(String args[]) {
        System.out.println(getLawyerDatabase());

    }

    public static AddressDataBase getLawyerDatabase() {
        Vector v = new Vector();
        for (int i = 1; i < 8; i++) {
            v.addAll(lookForIPLawyersInCt(i));
        }
        //This call populates the records vector
        String s[] = new String[v.size()];
        v.copyInto(s);
        return  parseLawyerRecords(s);
    }


    public static AddressDataBase parseLawyerRecords(String sa[]) {
        AddressDataBase adb = AddressDataBase.getAddressBookDatabase();
        String searchString1 = "\'sponseredL\'>";
        String searchString2 = "</a><strong><br>";
        String searchString3 = "<br><strong>";
        String searchString4 = "</strong>";
        String searchString5 = "U.S.A";
        String name = "";
        String addr = "";
        String note = "";
        boolean noteExists = true;
        AddressRecord ar;
        for (int i = 0; i < sa.length; i++) {
            String s = sa[i];
            ar = new AddressRecord();
            if (s.indexOf("class=\'sponseredL\'") == -1) continue;
            if (s.indexOf("U.S.A") == -1) continue;
            int j = -1;

            //Find practice name...
            j = s.indexOf(searchString1) + searchString1.length();
            String s1 = s.substring(j);
            j = s1.indexOf("<");
            name = s1.substring(0, j);
            ar.setName(name);

            //find address...
            s1 = s1.substring(j + 1 + searchString2.length());
            j = s1.indexOf(searchString3);//May not exist
            if (j == -1) {
                j = s1.indexOf(searchString5) + searchString5.length();
                noteExists = false;
            }
            addr = s1.substring(0, j);
            addr = addr.replaceAll("<B>", "");
            addr = addr.replaceAll("</B>", "");
            ar.setAddress(addr);

            //find any notes...
            if (noteExists == true) {
                s1 = s1.substring(j + searchString3.length());
                j = s1.indexOf(searchString4);
                if (j == -1) continue;
                note = s1.substring(0, j);
                ar.setInfo(note);
            } else {
                noteExists = true;
            }
            adb.addRecord(ar);
        }
        return adb;
    }

    public String toXml() {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        XMLEncoder e = new XMLEncoder(baos);
        e.writeObject(this);
        e.flush();
        return baos.toString();
    }


    public static String getOneBigUrlString(String urlString) {
        Vector v = getUrlVector(urlString);
        return getOneBigString(v);
    }

    private static String getOneBigString(Vector v) {
        String s[] = new String[v.size()];
        v.copyInto(s);
        return getOneBigUrlString(s);
    }

    public static String getOneBigUrlString(String s[]) {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < s.length; i++)
            sb.append(s[i] + '\n');
        return sb.toString();
    }

    public static String[] getUrlString(String urlString) {
        Vector v = getUrlVector(urlString);
        String s[] = new String[v.size()];
        v.copyInto(s);
        return s;
    }

    /**
     * Read a url and put it into a file. This is very good when dealing
     * with large files.
     *
     * @param url input file (like data.jar)
     * @param f   locally created output file.
     */
    public static void getUrl(URL url, File f)
            throws IOException {

        FileOutputStream fos = new FileOutputStream(f);
        BufferedInputStream bis = new
                BufferedInputStream(url.openStream());
        int numberOfBytesRead = 0;
        int buffSize = 65536;
        byte b[] = new byte[buffSize];
        ProgressDialog pd = new ProgressDialog();
        pd.setSize(200, 80);
        pd.setMinimum(0);
        pd.setMaximum(bis.available());
        pd.setUnits(" bytes transferred");
        int amountTransferred = 0;
        pd.setVisible(true);
        while ((numberOfBytesRead = bis.read(b)) != -1) {
            fos.write(b, 0, numberOfBytesRead);
            pd.setAmountDone(amountTransferred);
            amountTransferred = amountTransferred + numberOfBytesRead;
        }
        bis.close();
        fos.close();
        pd.setVisible(false);
    }

    /**
     * Read in entire url at once, into an array of bytes, and return.
     *
     * @param url
     * @return
     */
    public static byte[] getUrlBytes(URL url) {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        BufferedInputStream bis = null;
        byte b[] = new byte[4096];
        int numberOfBytesRead = 0;
        try {
            bis = new
                    BufferedInputStream(url.openStream());

            while ((numberOfBytesRead = bis.read(b)) != -1) {
                baos.write(b, 0, numberOfBytesRead);
            }

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (bis != null) bis.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return baos.toByteArray();
    }

    public static Vector getUrlVector(String _URLString) {
        Vector v = new Vector();
        BufferedReader br = null;
        try {
            URL url = new URL(_URLString);
            br = new BufferedReader(new
                    InputStreamReader(url.openStream()));

            String line;
            while (null != (line = br.readLine()))
                v.addElement(line);

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (br != null) br.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return v;
    }
}