package bookExamples.ch44Printing;

import gui.ClosableJFrame;
import gui.run.RunButton;
import utils.PrintUtils;

import javax.swing.*;
import java.awt.*;

import addbk.print.labels.LabelPanel;

/**
 * Copyright DocJava, inc. User: lyon
 * <p/>
 * Date: Jan 22, 2005
 * <p/>
 * Time: 10:26:08 AM
 */
public class PrintFrame extends ClosableJFrame {
    public static void main(String[] args) {
        new PrintFrame();
    }

    public PrintFrame() {
        super("Printing Swing Components");


        Container content = getContentPane();
        JPanel buttonPanel = new JPanel();
        buttonPanel.setBackground(Color.white);
        buttonPanel.add(new RunButton("Print") {
            public void run() {
                PrintUtils.printComponent(PrintFrame.this);
            }
        });
        content.add(buttonPanel, BorderLayout.SOUTH);
        LabelPanel lp = new LabelPanel();
        content.add(lp, BorderLayout.CENTER);
        pack();
        setVisible(true);
    }

}


